/*
 * AnachatChecker.cpp
 *
 *  Created on: 2012. 9. 10.
 *      Author: Yang
 */

#include <stdlib.h>
#include <signal.h>
#include <string>
#include <string.h>
#include <sys/socket.h>
#include <arpa/inet.h>
#include <unistd.h>
#include <stdio.h>
#include <sys/time.h>

using namespace std;

string g_serverId;

void printCurrenttime()
{
        time_t now = time(NULL);
        tm mytm;
        localtime_r(&now, &mytm);

        printf("[20%d-%d-%d %d:%d:%d] ", mytm.tm_year-100, mytm.tm_mon+1, mytm.tm_mday, mytm.tm_hour, mytm.tm_min, mytm.tm_sec);
}

bool setSocketOption(int fd, int timeoutSecond)
{
	struct timeval tv_timeo;
	tv_timeo.tv_sec = timeoutSecond;
	tv_timeo.tv_usec = 0;

	int optRcvResult = setsockopt(fd, SOL_SOCKET, SO_RCVTIMEO, &tv_timeo, sizeof(tv_timeo));
	int optSndResult = setsockopt(fd, SOL_SOCKET, SO_SNDTIMEO, &tv_timeo, sizeof(tv_timeo));
	if(optRcvResult == -1 || optSndResult == -1)
	{
		printf("SELF_CHECK: setsockopt() error");
		return false;
	}

	return true;
}


int tryConnect(int fd, int timeoutSecond, string serverIp, int serverPort)
{
	struct sockaddr_in serverAddr;
	memset(&serverAddr, 0, sizeof(serverAddr));
	serverAddr.sin_family = AF_INET;
	serverAddr.sin_addr.s_addr = inet_addr(serverIp.c_str());
	serverAddr.sin_port = htons(serverPort);

	alarm(timeoutSecond);
	int connResult = connect(fd, (struct sockaddr*)&serverAddr, sizeof(serverAddr));
	alarm(0);

	return connResult;
}

bool connectTest(string serverIp, int serverPort)
{
	int helloSocket = socket(PF_INET, SOCK_STREAM, 0);
	if(helloSocket == -1)
	{
		printf("SELF_CHECK: socket() error\n");
		return false;
	}

	int timeoutSecond = 20;

	if(setSocketOption(helloSocket, timeoutSecond) == false)
	{
		return false;
	}

	int connResult = tryConnect(helloSocket, timeoutSecond, serverIp, serverPort);
	close(helloSocket);
	printCurrenttime();

	if(connResult == -1)
	{
		printf("SELF_CHECK: %s:%d, %s, connect fail(%d)\n", serverIp.c_str(), serverPort, g_serverId.c_str(), connResult);
		return false;
	}
	else
	{
		printf("SELF_CHECK: %s:%d, %s, connect success(fd:%d)\n", serverIp.c_str(), serverPort, g_serverId.c_str(), helloSocket);
		return true;
	}
}

void killProcess(string serverId)
{
	//string command = "ps -ef | grep \"anachatd -n " + serverId + "\" | grep -v \"grep\"";
	//printf("command:%s\n", command.c_str());
	//system(command.c_str());

	string command = "pkill -f \"anachatd -n " + serverId+"\"";
	int result = system(command.c_str());

	printCurrenttime();
	printf("command:%s\n", command.c_str());
	if(result == 0)
	{
		printf("process kill success\n");
	}
	else
	{
		printf("process kill fail(%d)\n", result);
	}
}

void sigAlarmHandler(int signum)
{
	killProcess(g_serverId);
}

int main(int argc, char* argv[])
{
	char* serverIp = argv[1];
	int serverPort = atoi(argv[2]);
	char* serverId = argv[3];
	g_serverId = serverId;

	signal(SIGALRM, sigAlarmHandler);

	bool result = connectTest(serverIp, serverPort);
	if(result == false)
	{
		killProcess(serverId);
	}

	return 0;
}

